<?php

require_once 'NewsTestHelper.php';
use JsonApi\Routes\News\CommentsIndex;
use JsonApi\Routes\News\CommentsShow;

class CommentsShowTest extends \Codeception\Test\Unit
{
    use NewsTestHelper;

    /**
     * @var \UnitTester
     */
    protected $tester;

    protected function _before()
    {
        \DBManager::getInstance()->setConnection('studip', $this->getModule('\\Helper\\StudipDb')->dbh);
    }

    protected function _after()
    {
    }

    //testszenario:
    public function testShowAllComments()
    {
        $credentials = $this->tester->getCredentialsForRoot();
        $title = 'A testing title';
        $content = 'Lorem ipsum dolor sit amet, consectetur adipisicing elit';
        $news = $this->createNews($credentials, $title, $content);

        $response = $this->tester->callJsonApi(CommentsIndex::class, $credentials, ['id' => $news->id]);
    }

    public function testShowOneComment()
    {
        $credentials = $this->tester->getCredentialsForRoot();
        $title = 'A testing title';
        $content = 'Lorem ipsum dolor sit amet, consectetur adipisicing elit';
        $news = $this->createNews($credentials, $title, $content);
        $comment = $this->createComment($credentials, $news, $content);

        $response = $this->tester->callJsonApi(CommentsShow::class, $credentials, ['id' => $comment->id]);
        $this->tester->assertSame(200, $response->getStatusCode());
        $this->tester->assertTrue($response->isSuccessfulDocument([200]));
        $document = $response->document();
    }
}
