<?php

use JsonApi\Routes\Wiki\WikiShow;

class WikiShowTest extends \Codeception\Test\Unit
{
    /**
     * @var \UnitTester
     */
    protected $tester;

    protected function _before()
    {
        \DBManager::getInstance()->setConnection('studip', $this->getModule('\\Helper\\StudipDb')->dbh);
        \WikiPage::deleteBySQL('1');
    }

    protected function _after()
    {
    }

    //testszenario:
    public function testShowWiki()
    {
        $credentials = $this->tester->getCredentialsForTestAutor();
        $rangeId = 'a07535cf2f8a72df33c12ddfa4b53dde';

        $keyword = 'NEU';
        $content =
            'Es gibt im Moment in diese Mannschaft, oh, einige Spieler vergessenihren Profi was sie sind. Ich lese nicht sehr viele Zeitungen, aberich habe gehört viele Situationen. Erstens: Wir haben nicht offensivgespielt. Es gibt keine deutsche Mannschaft spielt offensiv und dieNamen offensiv wie Bayern. Letzte Spiel hatten wir in Platz dreiSpitzen: Elber, Jancker und dann Zickler. Wir mussen nicht vergessenZickler. Zickler ist eine Spitzen mehr, Mehmet mehr Basler. Ist klardiese Wörter, ist möglich verstehen, was ich hab’ gesagt? Danke.';
        $this->createWikiPage($rangeId, $keyword, $content);
        $this->tester->assertCount(1, \WikiPage::findBySQL('`range_id` = ?', [$rangeId]));

        $response = $this->tester->callJsonApi(WikiShow::class, $credentials, ['id' => $rangeId . '_' . $keyword]);

        $this->tester->assertTrue($response->isSuccessfulDocument([200]));

        $page = $response->document()->primaryResource();

        $this->tester->assertEquals($content, $page->attribute('content'));
    }

    private function createWikiPage($rangeId, $keyword, $content)
    {
        return $this->tester->withPHPLib($this->tester->getCredentialsForTestDozent(), function () use (
            $content,
            $keyword,
            $rangeId
        ) {
            return \WikiPage::create([
                'content' => $content,
                'name' => $keyword,
                'range_id' => $rangeId,
                'user_id' => 'nobody',
            ]);
        });
    }
}
